Add an AGL revision to the RPM package 67/16667/20
authorRonan Le Martret <ronan.lemartret@iot.bzh>
Tue, 18 Sep 2018 08:13:39 +0000 (08:13 +0000)
committerJan-Simon Moeller <jsmoeller@linuxfoundation.org>
Fri, 28 Sep 2018 13:24:00 +0000 (13:24 +0000)
* To update a rpm file (with dnf) we need to have a valid rpm revision.

  Let 2 packages pkg_1 and pkg_2 (built in yocto).
  If pkg_2 is newer than pkg_1, and one wants to be able to update it
  with dnf, it must respect some rpm naming rules.

  if ${pkg_2_name} > ${pkg_1_name}
     -> pkg_2 is newer than pkg_1
  elif ${pkg_2_name} = ${pkg_1_name} and ${pkg_2_revision} > ${pkg_1_revision}
     -> pkg_2 is newer than pkg_1
  else
     -> pkg_2 is equal or older than pkg_1

  Currently, the Yocto build process (used by AGL, so whithout special service)
  doesn't change revisions for a build. So packages are not updatable from a repository
  with dnf.

* This patch adds an option -r|--rpm-revision <schema> to aglsetup.sh so that RPMs
  produced by bitbake will have correct revisions suitable for binary publishing.

  <schema> can be:
    'prservice[:<address>]' : Use a PR service daemon.
        if <address> is not specified, the default value 'localhost:0'
        is used (shortcut for a PR service started by bitbake)
    'timestamp' : Use a generated time stamp (UTC).
    'value:<revision>' : Use <revision> explicitly.
    'none' : Do nothing.

p16: change --rpm-revision options parsing, use UTC timestamps, refactor code
p19: remove smart parsing of host:port for prservice option - back to dumb option

Bug-AGL: SPEC-920

Change-Id: I1f4c9fd093fa350d19450a12ac1847885740596d
Signed-off-by: Ronan Le Martret <ronan.lemartret@iot.bzh>
Signed-off-by: Johann CAHIER <johann.cahier@iot.bzh>
Signed-off-by: Ronan Le Martret <ronan.lemartret@iot.bzh>
Signed-off-by: Stephane Desneux <stephane.desneux@iot.bzh>
scripts/.aglsetup_genconfig.bash
templates/base/01_setup_pkg_revision.sh [new file with mode: 0644]

index d4f3ba8..b0d24e5 100755 (executable)
@@ -27,8 +27,8 @@
 #
 ################################################################################
 
-# this script shouldn't be called directly, but through aglsetup.sh that will in 
-# turn execute (source) generated instructions back in the parent shell, 
+# this script shouldn't be called directly, but through aglsetup.sh that will in
+# turn execute (source) generated instructions back in the parent shell,
 # whether it's bash, zsh, or any other supported shell
 
 VERSION=1.1.0
@@ -150,6 +150,15 @@ Options:
    -f|--force
       flag to force overwriting any existing configuration
       default: false
+   -r|--rpm-revision <schema>
+      Specify how to handle RPM packages revisions
+      <schema> can be:
+          'prservice[:<address>]' : Use a PR service daemon.
+              if <address> is not specified, the default value 'localhost:0'
+              is used (shortcut for a PR service started by bitbake)
+          'timestamp' : Use a generated time stamp (UTC).
+          'value:<revision>' : Use <revision> explicitly.
+          'none' : Do nothing.
    -v|--verbose
       verbose mode
       default: false
@@ -161,13 +170,13 @@ Options:
 
 EOF
        local buf
-       
+
        echo "Available machines:" >&2
        for x in $AGL_REPOSITORIES; do
                buf=$(list_machines $x)
                [[ -z "$buf" ]] && continue
                echo "   [$x]"
-               for y in $buf; do 
+               for y in $buf; do
                        [[ $y == $DEFAULT_MACHINE ]] && def="* " || def="  "
                        echo "     $def$y"
                done
@@ -281,7 +290,7 @@ function find_feature_dependency() {
 
 GLOBAL_ARGS=( "$@" )
 debug "Parsing arguments: $@"
-TEMP=$(getopt -o m:b:s:fvdh --long machine:,builddir:,script:,force,verbose,debug,help -n $SCRIPT -- "$@")
+TEMP=$(getopt -o m:b:r:s:fvdh --long machine:,builddir:,rpm-revision:,script:,force,verbose,debug,help -n $SCRIPT -- "$@")
 [[ $? != 0 ]] && { usage; exit 1; }
 eval set -- "$TEMP"
 
@@ -292,17 +301,18 @@ MACHINE=$DEFAULT_MACHINE
 BUILDDIR=$DEFAULT_BUILDDIR
 SETUPSCRIPT=
 FORCE=
-
+RPMREVISION=
 while true; do
        case "$1" in
-               -m|--machine)  MACHINE=$2; shift 2;;
-               -b|--builddir) BUILDDIR=$2; shift 2;;
-               -s|--setupscript) SETUPSCRIPT=$2; shift 2;;
-               -f|--force) FORCE=1; shift;;
-               -v|--verbose) VERBOSE=1; shift;;
-               -d|--debug) VERBOSE=1; DEBUG=1; shift;;
-               -h|--help)     HELP=1; shift;;
-               --)            shift; break;;
+               -m|--machine)      MACHINE=$2; shift 2;;
+               -b|--builddir)     BUILDDIR=$2; shift 2;;
+               -s|--setupscript)  SETUPSCRIPT=$2; shift 2;;
+               -f|--force)        FORCE=1; shift;;
+               -r|--rpm-revision) RPMREVISION=$2; shift 2;;
+               -v|--verbose)      VERBOSE=1; shift;;
+               -d|--debug)        VERBOSE=1; DEBUG=1; shift;;
+               -h|--help)         HELP=1; shift;;
+               --)                shift; break;;
                *) error "Arguments parsing error"; exit 1;;
        esac
 done
@@ -409,6 +419,8 @@ export MACHINE="$MACHINE"
 export FEATURES="$FEATURES"
 export BUILDDIR="$BUILDDIR"
 export METADIR="$METADIR"
+export RPMREVISION="$RPMREVISION"
+export LOCALCONF="$BUILDDIR/conf/local.conf"
 
 echo "--- beginning of setup script"
 EOF
@@ -432,7 +444,6 @@ EOF
                dump_log $BUILDDIR/conf/setup.log
                return 1
        }
-       # NOTE: the setup.sh script is removed if execution succeeded (only the log remains)
 }
 
 ###########################################################################################
@@ -447,7 +458,7 @@ EOF
 if [[ -f $BUILDDIR/conf/local.conf || -f $BUILDDIR/conf/bblayers.conf ]]; then
        info "Configuration files already exist:"
        for x in $BUILDDIR/conf/local.conf $BUILDDIR/conf/bblayers.conf; do
-               [[ -f $x ]] && info "   - $x" 
+               [[ -f $x ]] && info "   - $x"
        done
        info "Skipping configuration files generation."
        info "Use option -f|--force to overwrite existing configuration."
@@ -457,13 +468,14 @@ fi
 
 # always generate setup script in builddir: it can be sourced later manually without re-running the setup
 infon "Generating setup file: $BUILDDIR/agl-init-build-env ... "
+
 cat <<EOF >$BUILDDIR/agl-init-build-env
 . $METADIR/poky/oe-init-build-env $BUILDDIR
 if [ -n "\$DL_DIR" ]; then
        BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE DL_DIR"
 fi
 if [ -n "\$SSTATE_DIR" ]; then
-        BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE SSTATE_DIR" 
+       BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE SSTATE_DIR"
 fi
 export BB_ENV_EXTRAWHITE
 unset TEMPLATECONF
diff --git a/templates/base/01_setup_pkg_revision.sh b/templates/base/01_setup_pkg_revision.sh
new file mode 100644 (file)
index 0000000..af82c09
--- /dev/null
@@ -0,0 +1,68 @@
+# use a function to be neutral with other fragments
+function 01_setup_pkg_revision() {
+    # BASH_SOURCE can't be used as this fragment is concatenated in a larger script
+    local THIS=meta-agl/templates/base/01_setup_pkg_revision.sh
+
+    # RPMREVISION and LOCALCONF must be set previously in the setup script
+    [[ -z "$RPMREVISION" || -z "$LOCALCONF" ]] && return 0
+
+    echo "INFO: using RPM revision schema $RPMREVISION"
+
+    cat <<EOF >> $LOCALCONF
+
+# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
+# fragment {
+# generated by $THIS "$RPMREVISION"
+#
+
+EOF
+
+    case "$RPMREVISION" in
+        prservice*)
+            [[ $RPMREVISION =~ ^prservice(:([^ \t\n]+))?$ ]] && {
+                echo "PRSERV_HOST ?= \"${BASH_REMATCH[2]:-localhost:0}\"" >> $LOCALCONF
+            } || {
+                echo "ERROR ($THIS): invalid address specified for PR Service"
+                return 1
+            }
+            ;;
+        timestamp)
+            AGL_PR=$(date --utc '+%Y%m%d.%H%M%S')
+            cat <<'EOF' >> $LOCALCONF
+# to re-generate AGL_PR the same way as aglsetup does, run:
+#   echo "AGL_PR ?= \"$(date --utc '+%Y%m%d.%H%M%S')\""
+EOF
+            echo "AGL_PR ?= \"${AGL_PR}\"" >> $LOCALCONF;
+            cat <<'EOF' >> $LOCALCONF
+PKGR_append = ".${AGL_PR}"
+PKGV = "${@ '${PV}'.replace('AUTOINC','${AGL_PR}')}"
+BB_HASHBASE_WHITELIST_append = " PKGR PKGV"
+EOF
+            ;;
+        value:*)
+            echo "AGL_PR ?= \"${RPMREVISION#value:}\"" >> $LOCALCONF;
+            cat <<'EOF' >> $LOCALCONF
+PKGR_append = ".${AGL_PR}"
+PKGV = "${@ '${PV}'.replace('AUTOINC','${AGL_PR}')}"
+BB_HASHBASE_WHITELIST_append = " PKGR PKGV"
+EOF
+            ;;
+        none)
+            # do nothing
+            ;;
+        *)
+            echo "ERROR ($THIS): unknown package revision method '$REVISION'"
+            return 1
+            ;;
+    esac
+
+    cat <<'EOF' >> $LOCALCONF
+
+#
+# }
+# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
+EOF
+
+}
+
+01_setup_pkg_revision